/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips;

import ru.ispras.microtesk.model.ModelBuilder;
import ru.ispras.microtesk.model.minimips.metadata.MetaModelFactory;
import ru.ispras.microtesk.model.minimips.decoder.Decoder;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.minimips.op.*;

/**
 * The {@code Model} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class Model extends ModelBuilder {
  public Model() {
    super(
        "minimips",
        "",
        MetaModelFactory.newMetaModel(),
        Decoder.get(),
        PE.newFactory(),
        TempVars.newFactory()
        );

    addMode(REG.INFO);
    addMode(RCOP0.INFO);
    addMode(BRANCH_LABEL.INFO);
    addMode(BRANCH_IMM.INFO);
    addMode(JUMP_LABEL.INFO);
    addMode(JUMP_IMM.INFO);
    addMode(LA_ADDR.INFO);

    addOperation(add.INFO);
    addOperation(addi.INFO);
    addOperation(addu.INFO);
    addOperation(addiu.INFO);
    addOperation(sub.INFO);
    addOperation(subu.INFO);
    addOperation(mult.INFO);
    addOperation(multu.INFO);
    addOperation(and.INFO);
    addOperation(andi.INFO);
    addOperation(or.INFO);
    addOperation(ori.INFO);
    addOperation(nor.INFO);
    addOperation(xor.INFO);
    addOperation(xori.INFO);
    addOperation(sll.INFO);
    addOperation(sllv.INFO);
    addOperation(sra.INFO);
    addOperation(srav.INFO);
    addOperation(srl.INFO);
    addOperation(srlv.INFO);
    addOperation(lui.INFO);
    addOperation(lw.INFO);
    addOperation(sw.INFO);
    addOperation(mfhi.INFO);
    addOperation(mflo.INFO);
    addOperation(mthi.INFO);
    addOperation(mtlo.INFO);
    addOperation(swc0.INFO);
    addOperation(lwc0.INFO);
    addOperation(mfc0.INFO);
    addOperation(mtc0.INFO);
    addOperation(beq.INFO);
    addOperation(bgez.INFO);
    addOperation(bgezal.INFO);
    addOperation(bgtz.INFO);
    addOperation(blez.INFO);
    addOperation(bltz.INFO);
    addOperation(bltzal.INFO);
    addOperation(bne.INFO);
    addOperation(slt.INFO);
    addOperation(slti.INFO);
    addOperation(sltiu.INFO);
    addOperation(sltu.INFO);
    addOperation(j.INFO);
    addOperation(jr.INFO);
    addOperation(jal.INFO);
    addOperation(jalr.INFO);
    addOperation(syscall.INFO);
    addOperation(cop0.INFO);
    addOperation(mips_break.INFO);
    addOperation(nop.INFO);
    addOperation(instruction.INFO);
    addOperation(la.INFO);
    addOperation(exception.INFO);
    addOperation(instantiate.INFO);
  }
}
