/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.decoder;

import static ru.ispras.microtesk.model.minimips.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.minimips.mode.JUMP_IMM;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderJUMP_IMM} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderJUMP_IMM extends DecoderItem {
  private static DecoderJUMP_IMM instance = null;

  public static DecoderJUMP_IMM get() {
    if (null == instance) {
      instance = new DecoderJUMP_IMM();
    }
    return instance;
  }

  private DecoderJUMP_IMM() {
    super(
        26,
        true,
        null,
        null
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    Immediate imm = null;

    imm = readNextImmediate(image, Type.INT(26));

    return newResult(new JUMP_IMM(imm));
  }
}
