/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.mmu.spec;

import java.util.Collections;
import java.util.Arrays;
import java.math.BigInteger;
import ru.ispras.fortress.data.DataType;
import ru.ispras.fortress.expression.NodeVariable;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.fortress.expression.Nodes;
import ru.ispras.fortress.expression.NodeValue;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuBinding;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuBuffer;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuStruct;

/**
 * The {@code MMU_PA} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class MMU_PA extends MmuBuffer {
  private static MMU_PA INSTANCE = null;

  public static MMU_PA get() {
    if (null == INSTANCE) {
      INSTANCE = new MMU_PA();
    }
    return INSTANCE;
  }

  private final PA pa = PA.get();

  public static final class Entry extends MmuStruct {
    public final NodeVariable value;

    public Entry(final String name) {
      super(name);

      this.value = new NodeVariable(name + ".value", DataType.bitVector(32));

      addField(value);
    }
  }

  public final NodeVariable value;

  private MMU_PA() {
    this("MMU_PA");
  }

  private MMU_PA(final String name) {
    super(
        name,
        Kind.REGISTER,
        1L,
        1L,
        PA.get(),
        Nodes.FALSE,
        Nodes.FALSE,
        Nodes.bvextract(31, 0, PA.get().value),
        Collections.<MmuBinding>emptyList(), // set up with setMatchBindings
        false,
        null
    );

    this.value = new NodeVariable(name + ".value", DataType.bitVector(32));

    addField(value);
  }
}
