/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv;

import java.math.BigInteger;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.memory.Label;
import ru.ispras.microtesk.model.memory.Memory;

/**
 * The {@code PE} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class PE extends ProcessingElement {
  public final Memory XREG;
  public final Memory FPR;
  public final Memory PC;
  public final Memory MEM;
  public final Memory CSR;

  private PE() {
    super();
    this.XREG = Memory.def(Memory.Kind.REG, "XREG", TypeDefs.XWORD, 32);
    this.FPR = Memory.def(Memory.Kind.REG, "FPR", TypeDefs.XWORD, 32);
    this.PC = Memory.def(Memory.Kind.REG, "PC", TypeDefs.XWORD, 1);
    this.MEM = Memory.def(Memory.Kind.MEM, "MEM", TypeDefs.WORD, 0x4000000000000000L);
    this.CSR = Memory.def(Memory.Kind.REG, "CSR", TypeDefs.XWORD, 0x1000);

    registerAll();
  }

  private PE(final PE other, final boolean shared) {
    super(other);
    this.XREG = other.XREG.copy();
    this.FPR = other.FPR.copy();
    this.PC = other.PC.copy();
    this.MEM = shared ? other.MEM : other.MEM.copy();
    this.CSR = other.CSR.copy();

    registerAll();
  }

  private void registerAll() {
    addStorage(XREG);
    addStorage(FPR);
    addStorage(PC);
    addStorage(MEM);
    addStorage(CSR);
  }

  @Override
  public ProcessingElement copy(final boolean shared) {
    return new PE(this, shared);
  }

  private static final class PEFactory implements Factory {
    @Override
    public PE create() {
      return new PE();
    }
  }

  public static Factory newFactory() {
    return new PEFactory();
  }
}
