/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv;

import java.math.BigInteger;
import ru.ispras.microtesk.model.TemporaryVariables;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.memory.Memory;

/**
 * The {@code TempVars} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class TempVars extends TemporaryVariables {
  public final Memory prev_pc;
  public final Memory tmp_address;
  public final Memory tmp_index;
  public final Memory tmp_bit;
  public final Memory tmp_byte;
  public final Memory tmp_half;
  public final Memory tmp_dword;
  public final Memory tmp_word;
  public final Memory tmp_int1;
  public final Memory tmp_int2;
  public final Memory tmp_long1;
  public final Memory tmp_long2;
  public final Memory temp_fps;
  public final Memory temp_fps2;
  public final Memory temp_fps3;
  public final Memory temp_fpd;
  public final Memory temp_fpd2;
  public final Memory temp_fpd3;
  public final Memory tmp_bit_offset;
  public final Memory opcode_xtype;
  public final Memory funct3;
  public final Memory funct7;
  public final Memory temp_address_load;
  public final Memory temp_address_tail;
  public final Memory load_value;
  public final Memory RoundingMode;
  public final Memory tmp_rv64m;
  public final Memory tmp_rv32m;
  public final Memory csr_index;
  public final Memory jump_imm20;
  public final Memory jump_imm12;
  public final Memory jump_imm32;

  private TempVars() {
    this.prev_pc = Memory.def(Memory.Kind.VAR, "prev_pc", TypeDefs.XWORD, 1);
    this.tmp_address = Memory.def(Memory.Kind.VAR, "tmp_address", TypeDefs.XWORD, 1);
    this.tmp_index = Memory.def(Memory.Kind.VAR, "tmp_index", TypeDefs.XWORD, 1);
    this.tmp_bit = Memory.def(Memory.Kind.VAR, "tmp_bit", TypeDefs.BIT, 1);
    this.tmp_byte = Memory.def(Memory.Kind.VAR, "tmp_byte", TypeDefs.BYTE, 1);
    this.tmp_half = Memory.def(Memory.Kind.VAR, "tmp_half", TypeDefs.HWORD, 1);
    this.tmp_dword = Memory.def(Memory.Kind.VAR, "tmp_dword", TypeDefs.DWORD, 1);
    this.tmp_word = Memory.def(Memory.Kind.VAR, "tmp_word", TypeDefs.WORD, 1);
    this.tmp_int1 = Memory.def(Memory.Kind.VAR, "tmp_int1", TypeDefs.INT, 1);
    this.tmp_int2 = Memory.def(Memory.Kind.VAR, "tmp_int2", TypeDefs.INT, 1);
    this.tmp_long1 = Memory.def(Memory.Kind.VAR, "tmp_long1", TypeDefs.LONG, 1);
    this.tmp_long2 = Memory.def(Memory.Kind.VAR, "tmp_long2", TypeDefs.LONG, 1);
    this.temp_fps = Memory.def(Memory.Kind.VAR, "temp_fps", TypeDefs.FLOAT32, 1);
    this.temp_fps2 = Memory.def(Memory.Kind.VAR, "temp_fps2", TypeDefs.FLOAT32, 1);
    this.temp_fps3 = Memory.def(Memory.Kind.VAR, "temp_fps3", TypeDefs.FLOAT32, 1);
    this.temp_fpd = Memory.def(Memory.Kind.VAR, "temp_fpd", TypeDefs.FLOAT64, 1);
    this.temp_fpd2 = Memory.def(Memory.Kind.VAR, "temp_fpd2", TypeDefs.FLOAT64, 1);
    this.temp_fpd3 = Memory.def(Memory.Kind.VAR, "temp_fpd3", TypeDefs.FLOAT64, 1);
    this.tmp_bit_offset = Memory.def(Memory.Kind.VAR, "tmp_bit_offset", Type.CARD(5), 1);
    this.opcode_xtype = Memory.def(Memory.Kind.VAR, "opcode_xtype", Type.CARD(7), 1);
    this.funct3 = Memory.def(Memory.Kind.VAR, "funct3", Type.CARD(3), 1);
    this.funct7 = Memory.def(Memory.Kind.VAR, "funct7", Type.CARD(7), 1);
    this.temp_address_load = Memory.def(Memory.Kind.VAR, "temp_address_load", TypeDefs.DWORD, 1);
    this.temp_address_tail = Memory.def(Memory.Kind.VAR, "temp_address_tail", Type.CARD(2), 1);
    this.load_value = Memory.def(Memory.Kind.VAR, "load_value", TypeDefs.DWORD, 1);
    this.RoundingMode = Memory.def(Memory.Kind.VAR, "RoundingMode", Type.CARD(3), 1);
    this.tmp_rv64m = Memory.def(Memory.Kind.VAR, "tmp_rv64m", TypeDefs.XWORD, 1);
    this.tmp_rv32m = Memory.def(Memory.Kind.VAR, "tmp_rv32m", TypeDefs.XDWORD, 1);
    this.csr_index = Memory.def(Memory.Kind.VAR, "csr_index", Type.CARD(12), 1);
    this.jump_imm20 = Memory.def(Memory.Kind.VAR, "jump_imm20", Type.CARD(20), 1);
    this.jump_imm12 = Memory.def(Memory.Kind.VAR, "jump_imm12", Type.CARD(12), 1);
    this.jump_imm32 = Memory.def(Memory.Kind.VAR, "jump_imm32", Type.CARD(32), 1);

    addVariable(prev_pc);
    addVariable(tmp_address);
    addVariable(tmp_index);
    addVariable(tmp_bit);
    addVariable(tmp_byte);
    addVariable(tmp_half);
    addVariable(tmp_dword);
    addVariable(tmp_word);
    addVariable(tmp_int1);
    addVariable(tmp_int2);
    addVariable(tmp_long1);
    addVariable(tmp_long2);
    addVariable(temp_fps);
    addVariable(temp_fps2);
    addVariable(temp_fps3);
    addVariable(temp_fpd);
    addVariable(temp_fpd2);
    addVariable(temp_fpd3);
    addVariable(tmp_bit_offset);
    addVariable(opcode_xtype);
    addVariable(funct3);
    addVariable(funct7);
    addVariable(temp_address_load);
    addVariable(temp_address_tail);
    addVariable(load_value);
    addVariable(RoundingMode);
    addVariable(tmp_rv64m);
    addVariable(tmp_rv32m);
    addVariable(csr_index);
    addVariable(jump_imm20);
    addVariable(jump_imm12);
    addVariable(jump_imm32);
  }

  private static final class TempVarsFactory implements Factory {
    @Override
    public TempVars create() {
      return new TempVars();
    }
  }

  public static Factory newFactory() {
    return new TempVarsFactory();
  }
}
