/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.op.amomin_w;
import ru.ispras.microtesk.model.riscv.mode.X;

/**
 * The {@code DecoderAmomin_w} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderAmomin_w extends DecoderItem {
  private static DecoderAmomin_w instance = null;

  public static DecoderAmomin_w get() {
    if (null == instance) {
      instance = new DecoderAmomin_w();
    }
    return instance;
  }

  private DecoderAmomin_w() {
    super(
        32,
        true,
        "10000000000000000010000000101111",
        "11111110000000000111000001111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    X rd = null;
    X rs2 = null;
    X rs1 = null;

    if (!matchNextOpc(image, BitVector.valueOf("10000", 2, 5))) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("0", 2, 1))) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("0", 2, 1))) {
      return null;
    }

    rs2 = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rs2) {
      return null;
    }

    rs1 = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rs1) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("010", 2, 3))) {
      return null;
    }

    rd = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rd) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("0101111", 2, 7))) {
      return null;
    }

    return newResult(new amomin_w(rd, rs2, rs1));
  }
}
