/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.op.bge;
import ru.ispras.microtesk.model.riscv.mode.X;
import ru.ispras.microtesk.model.IsaPrimitive;
import ru.ispras.microtesk.model.riscv.op.branch_image;

/**
 * The {@code DecoderBge} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderBge extends DecoderItem {
  private static DecoderBge instance = null;

  public static DecoderBge get() {
    if (null == instance) {
      instance = new DecoderBge();
    }
    return instance;
  }

  private DecoderBge() {
    super(
        32,
        true,
        "00000000000000000101000001100011",
        "00000000000000000111000001111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    X rs1 = null;
    X rs2 = null;
    IsaPrimitive imm = null;

    final branch_image branch_image_instance;
    branch_image_instance = (branch_image) readNextPrimitive(image, DecoderBranch_image.get());
    if (null == branch_image_instance) {
      return null;
    }
    rs1 = branch_image_instance.rs1;
    rs2 = branch_image_instance.rs2;

    return newResult(new bge(rs1, rs2, imm));
  }
}
