/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.op.branch_image;
import ru.ispras.microtesk.model.riscv.mode.X;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderBranch_image} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderBranch_image extends DecoderItem {
  private static DecoderBranch_image instance = null;

  public static DecoderBranch_image get() {
    if (null == instance) {
      instance = new DecoderBranch_image();
    }
    return instance;
  }

  private DecoderBranch_image() {
    super(
        32,
        true,
        "00000000000000000000000001100011",
        "00000000000000000000000001111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    X rs1 = null;
    X rs2 = null;
    Immediate branch_index = null;



    rs2 = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rs2) {
      return null;
    }

    rs1 = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rs1) {
      return null;
    }

    branch_index = readNextImmediate(image, Type.CARD(3));



    if (!matchNextOpc(image, BitVector.valueOf("1100011", 2, 7))) {
      return null;
    }

    return newResult(new branch_image(rs1, rs2, branch_index));
  }
}
