/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.op.ebreak;

/**
 * The {@code DecoderEbreak} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderEbreak extends DecoderItem {
  private static DecoderEbreak instance = null;

  public static DecoderEbreak get() {
    if (null == instance) {
      instance = new DecoderEbreak();
    }
    return instance;
  }

  private DecoderEbreak() {
    super(
        32,
        true,
        "00000000000100000000000001110011",
        "11111111111111111111111111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    if (!matchNextOpc(image, BitVector.valueOf("000000000001", 2, 12))) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("00000", 2, 5))) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("000", 2, 3))) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("00000", 2, 5))) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("1110011", 2, 7))) {
      return null;
    }

    return newResult(new ebreak());
  }
}
