/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.op.fcvt_d_lu;
import ru.ispras.microtesk.model.riscv.mode.FR;
import ru.ispras.microtesk.model.riscv.mode.X;

/**
 * The {@code DecoderFcvt_d_lu} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderFcvt_d_lu extends DecoderItem {
  private static DecoderFcvt_d_lu instance = null;

  public static DecoderFcvt_d_lu get() {
    if (null == instance) {
      instance = new DecoderFcvt_d_lu();
    }
    return instance;
  }

  private DecoderFcvt_d_lu() {
    super(
        32,
        true,
        "11010010001100000000000001010011",
        "11111111111100000111000001111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    FR rd = null;
    X rs1 = null;

    if (!matchNextOpc(image, BitVector.valueOf("1101001", 2, 7))) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("00011", 2, 5))) {
      return null;
    }

    rs1 = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rs1) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("000", 2, 3))) {
      return null;
    }

    rd = (FR) readNextPrimitive(image, DecoderFR.get());
    if (null == rd) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("1010011", 2, 7))) {
      return null;
    }

    return newResult(new fcvt_d_lu(rd, rs1));
  }
}
