/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.op.fence_i;

/**
 * The {@code DecoderFence_i} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderFence_i extends DecoderItem {
  private static DecoderFence_i instance = null;

  public static DecoderFence_i get() {
    if (null == instance) {
      instance = new DecoderFence_i();
    }
    return instance;
  }

  private DecoderFence_i() {
    super(
        32,
        true,
        "00000000000000000001000000001111",
        "11111111111111111111111111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    if (!matchNextOpc(image, BitVector.valueOf("000000000000", 2, 12))) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("00000", 2, 5))) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("001", 2, 3))) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("00000", 2, 5))) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("0001111", 2, 7))) {
      return null;
    }

    return newResult(new fence_i());
  }
}
