/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.op.fle_s;
import ru.ispras.microtesk.model.riscv.mode.X;
import ru.ispras.microtesk.model.riscv.mode.FR;

/**
 * The {@code DecoderFle_s} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderFle_s extends DecoderItem {
  private static DecoderFle_s instance = null;

  public static DecoderFle_s get() {
    if (null == instance) {
      instance = new DecoderFle_s();
    }
    return instance;
  }

  private DecoderFle_s() {
    super(
        32,
        true,
        "10100000000000000000000001010011",
        "11111110000000000111000001111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    X rd = null;
    FR rs1 = null;
    FR rs2 = null;

    if (!matchNextOpc(image, BitVector.valueOf("1010000", 2, 7))) {
      return null;
    }

    rs2 = (FR) readNextPrimitive(image, DecoderFR.get());
    if (null == rs2) {
      return null;
    }

    rs1 = (FR) readNextPrimitive(image, DecoderFR.get());
    if (null == rs1) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("000", 2, 3))) {
      return null;
    }

    rd = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rd) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("1010011", 2, 7))) {
      return null;
    }

    return newResult(new fle_s(rd, rs1, rs2));
  }
}
