/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.op.fmul_d;
import ru.ispras.microtesk.model.riscv.mode.FR;

/**
 * The {@code DecoderFmul_d} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderFmul_d extends DecoderItem {
  private static DecoderFmul_d instance = null;

  public static DecoderFmul_d get() {
    if (null == instance) {
      instance = new DecoderFmul_d();
    }
    return instance;
  }

  private DecoderFmul_d() {
    super(
        32,
        true,
        "00010010000000000000000001010011",
        "11111110000000000111000001111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    FR rd = null;
    FR rs1 = null;
    FR rs2 = null;

    if (!matchNextOpc(image, BitVector.valueOf("0001001", 2, 7))) {
      return null;
    }

    rs2 = (FR) readNextPrimitive(image, DecoderFR.get());
    if (null == rs2) {
      return null;
    }

    rs1 = (FR) readNextPrimitive(image, DecoderFR.get());
    if (null == rs1) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("000", 2, 3))) {
      return null;
    }

    rd = (FR) readNextPrimitive(image, DecoderFR.get());
    if (null == rd) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("1010011", 2, 7))) {
      return null;
    }

    return newResult(new fmul_d(rd, rs1, rs2));
  }
}
