/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.op.fsd;
import ru.ispras.microtesk.model.riscv.mode.FR;
import ru.ispras.microtesk.model.riscv.mode.X;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderFsd} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderFsd extends DecoderItem {
  private static DecoderFsd instance = null;

  public static DecoderFsd get() {
    if (null == instance) {
      instance = new DecoderFsd();
    }
    return instance;
  }

  private DecoderFsd() {
    super(
        32,
        true,
        "00000000000000000011000000100111",
        "00000000000000000111000001111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    FR rs2 = null;
    X rs1 = null;
    Immediate imm = null;

    imm = new Immediate(Type.CARD(12));
    imm.access().bitField(11, 5).store(readNextImmediate(image, Type.CARD(7)).access());

    rs2 = (FR) readNextPrimitive(image, DecoderFR.get());
    if (null == rs2) {
      return null;
    }

    rs1 = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rs1) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("011", 2, 3))) {
      return null;
    }

    imm.access().bitField(4, 0).store(readNextImmediate(image, Type.CARD(5)).access());

    if (!matchNextOpc(image, BitVector.valueOf("0100111", 2, 7))) {
      return null;
    }

    return newResult(new fsd(rs2, rs1, imm));
  }
}
