/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.op.jal;
import ru.ispras.microtesk.model.riscv.mode.X;
import ru.ispras.microtesk.model.IsaPrimitive;

/**
 * The {@code DecoderJal} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderJal extends DecoderItem {
  private static DecoderJal instance = null;

  public static DecoderJal get() {
    if (null == instance) {
      instance = new DecoderJal();
    }
    return instance;
  }

  private DecoderJal() {
    super(
        32,
        true,
        "00000000000000000000000001101111",
        "00000000000000000000000001111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    X rd = null;
    IsaPrimitive imm = null;





    rd = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rd) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("1101111", 2, 7))) {
      return null;
    }

    return newResult(new jal(rd, imm));
  }
}
