/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.op.slti;
import ru.ispras.microtesk.model.riscv.mode.X;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderSlti} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderSlti extends DecoderItem {
  private static DecoderSlti instance = null;

  public static DecoderSlti get() {
    if (null == instance) {
      instance = new DecoderSlti();
    }
    return instance;
  }

  private DecoderSlti() {
    super(
        32,
        true,
        "00000000000000000010000000010011",
        "00000000000000000111000001111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    X rd = null;
    X rs1 = null;
    Immediate imm = null;

    imm = readNextImmediate(image, Type.CARD(12));

    rs1 = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rs1) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("010", 2, 3))) {
      return null;
    }

    rd = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rd) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("0010011", 2, 7))) {
      return null;
    }

    return newResult(new slti(rd, rs1, imm));
  }
}
