/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.metadata;

import ru.ispras.microtesk.model.metadata.MetaGroup;

/**
 * The {@code CSR_MODE} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class CSR_MODE extends MetaGroup {
  private static CSR_MODE instance = null;

  public static CSR_MODE get() {
    if (null == instance) {
      instance = new CSR_MODE();
    }
    return instance;
  }

  private CSR_MODE() {
    super(
        MetaGroup.Kind.MODE,
        "CSR_MODE",
        USTATUS.get(),
        UIE.get(),
        UTVEC.get(),
        USCRATCH.get(),
        UEPC.get(),
        UCAUSE.get(),
        UTVAL.get(),
        UIP.get(),
        FFLAGS.get(),
        FRM.get(),
        FCSR.get(),
        CYCLE.get(),
        TIME.get(),
        INSTRET.get(),
        HPMCOUNTER3.get(),
        HPMCOUNTER4.get(),
        HPMCOUNTER5.get(),
        HPMCOUNTER6.get(),
        HPMCOUNTER7.get(),
        HPMCOUNTER8.get(),
        HPMCOUNTER9.get(),
        HPMCOUNTER10.get(),
        HPMCOUNTER11.get(),
        HPMCOUNTER12.get(),
        HPMCOUNTER13.get(),
        HPMCOUNTER14.get(),
        HPMCOUNTER15.get(),
        HPMCOUNTER16.get(),
        HPMCOUNTER17.get(),
        HPMCOUNTER18.get(),
        HPMCOUNTER19.get(),
        HPMCOUNTER20.get(),
        HPMCOUNTER21.get(),
        HPMCOUNTER22.get(),
        HPMCOUNTER23.get(),
        HPMCOUNTER24.get(),
        HPMCOUNTER25.get(),
        HPMCOUNTER26.get(),
        HPMCOUNTER27.get(),
        HPMCOUNTER28.get(),
        HPMCOUNTER29.get(),
        HPMCOUNTER30.get(),
        HPMCOUNTER31.get(),
        SSTATUS.get(),
        SEDELEG.get(),
        SIDELEG.get(),
        SIE.get(),
        STVEC.get(),
        SCOUNTEREN.get(),
        SSCRATCH.get(),
        SEPC.get(),
        SCAUSE.get(),
        STVAL.get(),
        SIP.get(),
        SATP.get(),
        MVENDORID.get(),
        MARCHID.get(),
        MIMPID.get(),
        MHARTID.get(),
        MSTATUS.get(),
        MISA.get(),
        MEDELEG.get(),
        MIDELEG.get(),
        MIE.get(),
        MTVEC.get(),
        MCOUNTEREN.get(),
        MSCRATCH.get(),
        MEPC.get(),
        MCAUSE.get(),
        MTVAL.get(),
        MIP.get(),
        PMPCFG0.get(),
        PMPCFG1.get(),
        PMPCFG2.get(),
        PMPCFG3.get(),
        PMPADDR0.get(),
        PMPADDR1.get(),
        PMPADDR2.get(),
        PMPADDR3.get(),
        PMPADDR4.get(),
        PMPADDR5.get(),
        PMPADDR6.get(),
        PMPADDR7.get(),
        PMPADDR8.get(),
        PMPADDR9.get(),
        PMPADDR10.get(),
        PMPADDR11.get(),
        PMPADDR12.get(),
        PMPADDR13.get(),
        PMPADDR14.get(),
        PMPADDR15.get(),
        MCYCLE.get(),
        MINSTRET.get(),
        MHPMCOUNTER3.get(),
        MHPMCOUNTER4.get(),
        MHPMCOUNTER5.get(),
        MHPMCOUNTER6.get(),
        MHPMCOUNTER7.get(),
        MHPMCOUNTER8.get(),
        MHPMCOUNTER9.get(),
        MHPMCOUNTER10.get(),
        MHPMCOUNTER11.get(),
        MHPMCOUNTER12.get(),
        MHPMCOUNTER13.get(),
        MHPMCOUNTER14.get(),
        MHPMCOUNTER15.get(),
        MHPMCOUNTER16.get(),
        MHPMCOUNTER17.get(),
        MHPMCOUNTER18.get(),
        MHPMCOUNTER19.get(),
        MHPMCOUNTER20.get(),
        MHPMCOUNTER21.get(),
        MHPMCOUNTER22.get(),
        MHPMCOUNTER23.get(),
        MHPMCOUNTER24.get(),
        MHPMCOUNTER25.get(),
        MHPMCOUNTER26.get(),
        MHPMCOUNTER27.get(),
        MHPMCOUNTER28.get(),
        MHPMCOUNTER29.get(),
        MHPMCOUNTER30.get(),
        MHPMCOUNTER31.get(),
        MHPMEVENT3.get(),
        MHPMEVENT4.get(),
        MHPMEVENT5.get(),
        MHPMEVENT6.get(),
        MHPMEVENT7.get(),
        MHPMEVENT8.get(),
        MHPMEVENT9.get(),
        MHPMEVENT10.get(),
        MHPMEVENT11.get(),
        MHPMEVENT12.get(),
        MHPMEVENT13.get(),
        MHPMEVENT14.get(),
        MHPMEVENT15.get(),
        MHPMEVENT16.get(),
        MHPMEVENT17.get(),
        MHPMEVENT18.get(),
        MHPMEVENT19.get(),
        MHPMEVENT20.get(),
        MHPMEVENT21.get(),
        MHPMEVENT22.get(),
        MHPMEVENT23.get(),
        MHPMEVENT24.get(),
        MHPMEVENT25.get(),
        MHPMEVENT26.get(),
        MHPMEVENT27.get(),
        MHPMEVENT28.get(),
        MHPMEVENT29.get(),
        MHPMEVENT30.get(),
        MHPMEVENT31.get(),
        TSELECT.get(),
        TDATA1.get(),
        TDATA2.get(),
        TDATA3.get(),
        DCSR.get(),
        DPC.get(),
        DSCRATCH.get()
        );
  }
}
