/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class call extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "call",
          call.class,
          null
          );
      addArgument("symbol", PSEUDO_OFFSET.INFO);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final IsaPrimitive symbol = (IsaPrimitive) getArgument("symbol", args);

      return new call(symbol);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final IsaPrimitive symbol;

  public call(final IsaPrimitive symbol) {
    assert PSEUDO_OFFSET.INFO.isSupported(symbol);

    this.symbol = symbol;

    addArgument("symbol", symbol);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    symbol.init(vars__);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("call %s", symbol.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%s%s", new auipc(new X(new Immediate(Data.valueOf(Type.CARD(5), 0x6))), new Immediate(vars__.jump_imm32.access().bitField(31, 12))).image(vars__), new jalr(new X(new Immediate(Data.valueOf(Type.CARD(5), 0x1))), new X(new Immediate(Data.valueOf(Type.CARD(5), 0x6))), new BRANCH_IMM(new Immediate(vars__.jump_imm32.access().bitField(11, 0)))).image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    vars__.tmp_word.access().store(symbol.access(pe__, vars__).load());
    new instruction(new auipc(new X(new Immediate(Data.valueOf(Type.CARD(5), 0x6))), new Immediate(vars__.tmp_word.access().bitField(31, 12)))).execute(pe__, vars__);
    new instruction(new jalr(new X(new Immediate(Data.valueOf(Type.CARD(5), 0x1))), new X(new Immediate(Data.valueOf(Type.CARD(5), 0x6))), new BRANCH_IMM(new Immediate(vars__.tmp_word.access().bitField(11, 0))))).execute(pe__, vars__);
  }
}