/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class csrrci extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "csrrci",
          csrrci.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("csr", CSR_MODE.INFO);
      addArgument("imm", Type.CARD(5));
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final IsaPrimitive csr = (IsaPrimitive) getArgument("csr", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new csrrci(rd, csr, imm);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "csrrci",
          instruction.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("csr", CSR_MODE.INFO);
      addArgument("imm", Type.CARD(5));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final IsaPrimitive csr = (IsaPrimitive) getArgument("csr", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new instruction(
        new csrrci(
          rd,
          csr,
          imm
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final X rd;
  public final IsaPrimitive csr;
  public final Immediate imm;

  public csrrci(final X rd, final IsaPrimitive csr, final Immediate imm) {
    assert X.INFO.isSupported(rd);
    assert CSR_MODE.INFO.isSupported(csr);
    assert Type.CARD(5).equals(imm.getType());

    this.rd = rd;
    this.csr = csr;
    this.imm = imm;

    addArgument("rd", rd);
    addArgument("csr", csr);
    addArgument("imm", imm);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("csrrci %s, %s, 0x%x", rd.text(vars__), csr.text(vars__), imm.access().load().bigIntegerValue(false));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("%12s%5s111%5s1110011", csr.image(vars__), imm.access().load().toString(), rd.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    if (!imm.access().load().equals(Data.valueOf(Type.CARD(5), 0x0))) {
      csr.access(pe__, vars__).store(csr.access(pe__, vars__).load().and(Data.zeroExtend(XWORD, imm.access().load()).not()));
    }
    rd.access(pe__, vars__).store(csr.access(pe__, vars__).load());
  }
}