/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class csrrs extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "csrrs",
          csrrs.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("csr", CSR_MODE.INFO);
      addArgument("rs1", X.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final IsaPrimitive csr = (IsaPrimitive) getArgument("csr", args);
      final X rs1 = (X) getArgument("rs1", args);

      return new csrrs(rd, csr, rs1);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "csrrs",
          instruction.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("csr", CSR_MODE.INFO);
      addArgument("rs1", X.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final IsaPrimitive csr = (IsaPrimitive) getArgument("csr", args);
      final X rs1 = (X) getArgument("rs1", args);

      return new instruction(
        new csrrs(
          rd,
          csr,
          rs1
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final X rd;
  public final IsaPrimitive csr;
  public final X rs1;

  public csrrs(final X rd, final IsaPrimitive csr, final X rs1) {
    assert X.INFO.isSupported(rd);
    assert CSR_MODE.INFO.isSupported(csr);
    assert X.INFO.isSupported(rs1);

    this.rd = rd;
    this.csr = csr;
    this.rs1 = rs1;

    addArgument("rd", rd);
    addArgument("csr", csr);
    addArgument("rs1", rs1);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("csrrs %s, %s, %s", rd.text(vars__), csr.text(vars__), rs1.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("%12s%5s010%5s1110011", csr.image(vars__), rs1.image(vars__), rd.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    if (!rs1.i.access().load().equals(Data.valueOf(Type.CARD(5), 0x0))) {
      csr.access(pe__, vars__).store(csr.access(pe__, vars__).load().or(rs1.access(pe__, vars__).load()));
    }
    rd.access(pe__, vars__).store(csr.access(pe__, vars__).load());
  }
}