/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class fcvt_s_d extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "fcvt_s_d",
          fcvt_s_d.class,
          null
          );
      addArgument("rd", FR.INFO);
      addArgument("rs1", FR.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final FR rd = (FR) getArgument("rd", args);
      final FR rs1 = (FR) getArgument("rs1", args);

      return new fcvt_s_d(rd, rs1);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "fcvt_s_d",
          instruction.class,
          null
          );
      addArgument("rd", FR.INFO);
      addArgument("rs1", FR.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final FR rd = (FR) getArgument("rd", args);
      final FR rs1 = (FR) getArgument("rs1", args);

      return new instruction(
        new fcvt_s_d(
          rd,
          rs1
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final FR rd;
  public final FR rs1;

  public fcvt_s_d(final FR rd, final FR rs1) {
    assert FR.INFO.isSupported(rd);
    assert FR.INFO.isSupported(rs1);

    this.rd = rd;
    this.rs1 = rs1;

    addArgument("rd", rd);
    addArgument("rs1", rs1);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("fcvt.s.d %s, %s", rd.text(vars__), rs1.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("0100000%5s%5s%3s%5s1010011", "00001", rs1.image(vars__), Data.valueOf(Type.CARD(3), 0x0).toString(), rd.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    rd.access(pe__, vars__).store(Data.valueOf(XWORD, 0x0));
    vars__.temp_fpd.access().store(Data.cast(FLOAT64, rs1.access(pe__, vars__).bitField(63, 0).load()));
    rd.access(pe__, vars__).bitField(31, 0).store(Data.floatToFloat(FLOAT32, vars__.temp_fpd.access().load()));
  }
}