/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class fmax_d extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "fmax_d",
          fmax_d.class,
          null
          );
      addArgument("rd", FR.INFO);
      addArgument("rs1", FR.INFO);
      addArgument("rs2", FR.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final FR rd = (FR) getArgument("rd", args);
      final FR rs1 = (FR) getArgument("rs1", args);
      final FR rs2 = (FR) getArgument("rs2", args);

      return new fmax_d(rd, rs1, rs2);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "fmax_d",
          instruction.class,
          null
          );
      addArgument("rd", FR.INFO);
      addArgument("rs1", FR.INFO);
      addArgument("rs2", FR.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final FR rd = (FR) getArgument("rd", args);
      final FR rs1 = (FR) getArgument("rs1", args);
      final FR rs2 = (FR) getArgument("rs2", args);

      return new instruction(
        new fmax_d(
          rd,
          rs1,
          rs2
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final FR rd;
  public final FR rs1;
  public final FR rs2;

  public fmax_d(final FR rd, final FR rs1, final FR rs2) {
    assert FR.INFO.isSupported(rd);
    assert FR.INFO.isSupported(rs1);
    assert FR.INFO.isSupported(rs2);

    this.rd = rd;
    this.rs1 = rs1;
    this.rs2 = rs2;

    addArgument("rd", rd);
    addArgument("rs1", rs1);
    addArgument("rs2", rs2);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("fmax.d %s, %s, %s", rd.text(vars__), rs1.text(vars__), rs2.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("0010101%5s%5s%3s%5s1010011", rs2.image(vars__), rs1.image(vars__), "001", rd.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.temp_fpd.access().store(Data.cast(FLOAT64, rs1.access(pe__, vars__).bitField(63, 0).load()));
    vars__.temp_fpd2.access().store(Data.cast(FLOAT64, rs2.access(pe__, vars__).bitField(63, 0).load()));
    rd.access(pe__, vars__).store(Data.valueOf(XWORD, 0x0));
    if ((vars__.temp_fpd.access().load().compareTo(vars__.temp_fpd2.access().load()) > 0)) {
      rd.access(pe__, vars__).bitField(63, 0).store(vars__.temp_fpd.access().bitField(63, 0).load());
    } else {
      rd.access(pe__, vars__).bitField(63, 0).store(vars__.temp_fpd2.access().bitField(63, 0).load());
    }
  }
}