/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class fnmadd_s extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "fnmadd_s",
          fnmadd_s.class,
          null
          );
      addArgument("rd", FR.INFO);
      addArgument("rs1", FR.INFO);
      addArgument("rs2", FR.INFO);
      addArgument("rs3", FR.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final FR rd = (FR) getArgument("rd", args);
      final FR rs1 = (FR) getArgument("rs1", args);
      final FR rs2 = (FR) getArgument("rs2", args);
      final FR rs3 = (FR) getArgument("rs3", args);

      return new fnmadd_s(rd, rs1, rs2, rs3);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "fnmadd_s",
          instruction.class,
          null
          );
      addArgument("rd", FR.INFO);
      addArgument("rs1", FR.INFO);
      addArgument("rs2", FR.INFO);
      addArgument("rs3", FR.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final FR rd = (FR) getArgument("rd", args);
      final FR rs1 = (FR) getArgument("rs1", args);
      final FR rs2 = (FR) getArgument("rs2", args);
      final FR rs3 = (FR) getArgument("rs3", args);

      return new instruction(
        new fnmadd_s(
          rd,
          rs1,
          rs2,
          rs3
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final FR rd;
  public final FR rs1;
  public final FR rs2;
  public final FR rs3;

  public fnmadd_s(final FR rd, final FR rs1, final FR rs2, final FR rs3) {
    assert FR.INFO.isSupported(rd);
    assert FR.INFO.isSupported(rs1);
    assert FR.INFO.isSupported(rs2);
    assert FR.INFO.isSupported(rs3);

    this.rd = rd;
    this.rs1 = rs1;
    this.rs2 = rs2;
    this.rs3 = rs3;

    addArgument("rd", rd);
    addArgument("rs1", rs1);
    addArgument("rs2", rs2);
    addArgument("rs3", rs3);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("fnmadd.s %s, %s, %s, %s", rd.text(vars__), rs1.text(vars__), rs2.text(vars__), rs3.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("%5s00%5s%5s%3s%5s1001111", rs3.image(vars__), rs2.image(vars__), rs1.image(vars__), Data.valueOf(Type.CARD(3), 0x0).toString(), rd.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.tmp_int1.access().store(Data.valueOf(INT, 0xffffffffL));
    vars__.temp_fps2.access().store(Data.intToFloat(FLOAT32, vars__.tmp_int1.access().load()));
    vars__.temp_fps.access().store(vars__.temp_fps2.access().load().multiply(Data.cast(FLOAT32, rs1.access(pe__, vars__).bitField(31, 0).load())).multiply(Data.cast(FLOAT32, rs2.access(pe__, vars__).bitField(31, 0).load())).add(Data.cast(FLOAT32, rs3.access(pe__, vars__).bitField(31, 0).load())));
    rd.access(pe__, vars__).store(Data.valueOf(XWORD, 0x0));
    rd.access(pe__, vars__).bitField(31, 0).store(vars__.temp_fps.access().bitField(31, 0).load());
  }
}