/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class fsd_global extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "fsd_global",
          fsd_global.class,
          null
          );
      addArgument("rd", FR.INFO);
      addArgument("rt", X.INFO);
      addArgument("symbol", PSEUDO_OFFSET.INFO);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final FR rd = (FR) getArgument("rd", args);
      final X rt = (X) getArgument("rt", args);
      final IsaPrimitive symbol = (IsaPrimitive) getArgument("symbol", args);

      return new fsd_global(rd, rt, symbol);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final FR rd;
  public final X rt;
  public final IsaPrimitive symbol;

  public fsd_global(final FR rd, final X rt, final IsaPrimitive symbol) {
    assert FR.INFO.isSupported(rd);
    assert X.INFO.isSupported(rt);
    assert PSEUDO_OFFSET.INFO.isSupported(symbol);

    this.rd = rd;
    this.rt = rt;
    this.symbol = symbol;

    addArgument("rd", rd);
    addArgument("rt", rt);
    addArgument("symbol", symbol);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    symbol.init(vars__);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("fsd %s, %s(%s)", rd.text(vars__), symbol.text(vars__), rt.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%s%s", new auipc(rt, new Immediate(vars__.jump_imm32.access().bitField(31, 12))).image(vars__), new fsd(rd, rt, new Immediate(vars__.jump_imm32.access().bitField(11, 0))).image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    vars__.tmp_word.access().store(symbol.access(pe__, vars__).load());
    new instruction(new auipc(rt, new Immediate(vars__.tmp_word.access().bitField(31, 12)))).execute(pe__, vars__);
    new instruction(new fsd(rd, rt, new Immediate(vars__.tmp_word.access().bitField(11, 0)))).execute(pe__, vars__);
  }
}