/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class fsw extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "fsw",
          fsw.class,
          null
          );
      addArgument("rs2", FR.INFO);
      addArgument("rs1", X.INFO);
      addArgument("imm", Type.CARD(12));
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final FR rs2 = (FR) getArgument("rs2", args);
      final X rs1 = (X) getArgument("rs1", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new fsw(rs2, rs1, imm);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "fsw",
          instruction.class,
          null
          );
      addArgument("rs2", FR.INFO);
      addArgument("rs1", X.INFO);
      addArgument("imm", Type.CARD(12));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final FR rs2 = (FR) getArgument("rs2", args);
      final X rs1 = (X) getArgument("rs1", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new instruction(
        new fsw(
          rs2,
          rs1,
          imm
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final FR rs2;
  public final X rs1;
  public final Immediate imm;

  public fsw(final FR rs2, final X rs1, final Immediate imm) {
    assert FR.INFO.isSupported(rs2);
    assert X.INFO.isSupported(rs1);
    assert Type.CARD(12).equals(imm.getType());

    this.rs2 = rs2;
    this.rs1 = rs1;
    this.imm = imm;

    addArgument("rs2", rs2);
    addArgument("rs1", rs1);
    addArgument("imm", imm);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("fsw %s, 0x%x(%s)", rs2.text(vars__), imm.access().load().bigIntegerValue(false), rs1.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("%7s%5s%5s010%5s0100111", imm.access().bitField(11, 5).load().toString(), rs2.image(vars__), rs1.image(vars__), imm.access().bitField(4, 0).load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.tmp_address.access().store(rs1.access(pe__, vars__).load().add(Data.signExtend(XWORD, imm.access().load())));
    new store_data(new Immediate(Data.valueOf(Type.CARD(4), 0x4)), new Immediate(vars__.tmp_address.access()), new Immediate(Data.zeroExtend(DWORD, rs2.access(pe__, vars__).bitField(31, 0).load()))).execute(pe__, vars__);
  }
}