/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class la extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "la",
          la.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("symbol", PSEUDO_OFFSET.INFO);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final IsaPrimitive symbol = (IsaPrimitive) getArgument("symbol", args);

      return new la(rd, symbol);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final X rd;
  public final IsaPrimitive symbol;

  public la(final X rd, final IsaPrimitive symbol) {
    assert X.INFO.isSupported(rd);
    assert PSEUDO_OFFSET.INFO.isSupported(symbol);

    this.rd = rd;
    this.symbol = symbol;

    addArgument("rd", rd);
    addArgument("symbol", symbol);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    symbol.init(vars__);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("la %s, %s", rd.text(vars__), symbol.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%s%s", new auipc(rd, new Immediate((vars__.jump_imm32.access().bitField(11, 11).load().equals(Data.valueOf(Type.CARD(1), 0x0)) ? vars__.jump_imm32.access().bitField(31, 12).load() : vars__.jump_imm32.access().bitField(31, 12).load().add(Data.valueOf(Type.CARD(20), 0x1))))).image(vars__), new addi(rd, rd, new Immediate(vars__.jump_imm32.access().bitField(11, 0))).image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new instruction(new auipc(rd, new Immediate((symbol.access(pe__, vars__).bitField(11, 11).load().equals(Data.valueOf(Type.CARD(1), 0x0)) ? symbol.access(pe__, vars__).bitField(31, 12).load() : symbol.access(pe__, vars__).bitField(31, 12).load().add(Data.valueOf(Type.CARD(20), 0x1)))))).execute(pe__, vars__);
    new instruction(new addi(rd, rd, new Immediate(symbol.access(pe__, vars__).bitField(11, 0)))).execute(pe__, vars__);
  }
}