/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class lbu extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "lbu",
          lbu.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("rs1", X.INFO);
      addArgument("imm", Type.CARD(12));
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final X rs1 = (X) getArgument("rs1", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new lbu(rd, rs1, imm);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "lbu",
          instruction.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("rs1", X.INFO);
      addArgument("imm", Type.CARD(12));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final X rs1 = (X) getArgument("rs1", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new instruction(
        new lbu(
          rd,
          rs1,
          imm
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final X rd;
  public final X rs1;
  public final Immediate imm;

  public lbu(final X rd, final X rs1, final Immediate imm) {
    assert X.INFO.isSupported(rd);
    assert X.INFO.isSupported(rs1);
    assert Type.CARD(12).equals(imm.getType());

    this.rd = rd;
    this.rs1 = rs1;
    this.imm = imm;

    addArgument("rd", rd);
    addArgument("rs1", rs1);
    addArgument("imm", imm);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("lbu %s, %s(%s)", rd.text(vars__), new print_imm12(imm).text(vars__), rs1.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("%12s%s100%s0000011", imm.access().load().toString(), rs1.image(vars__), rd.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.tmp_address.access().store(rs1.access(pe__, vars__).load().add(Data.signExtend(XWORD, imm.access().load())));
    vars__.tmp_bit_offset.access().store(Data.zeroExtend(Type.CARD(5), vars__.tmp_address.access().bitField(1, 0).load()).multiply(Data.valueOf(Type.CARD(5), 0x8)));
    vars__.tmp_byte.access().store(pe__.MEM.access(vars__.tmp_address.access().load().shiftRight(Data.valueOf(XWORD, 0x2))).bitField(vars__.tmp_bit_offset.access().load().add(Data.valueOf(Type.CARD(5), 0x7)), vars__.tmp_bit_offset.access().load()).load());
    rd.access(pe__, vars__).store(Data.zeroExtend(XWORD, vars__.tmp_byte.access().load()));
  }
}