/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class lh_global2 extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "lh_global2",
          lh_global2.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("symbol", PSEUDO_OFFSET.INFO);
      addArgument("imm", Type.INT(32));}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final IsaPrimitive symbol = (IsaPrimitive) getArgument("symbol", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new lh_global2(rd, symbol, imm);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final X rd;
  public final IsaPrimitive symbol;
  public final Immediate imm;

  public lh_global2(final X rd, final IsaPrimitive symbol, final Immediate imm) {
    assert X.INFO.isSupported(rd);
    assert PSEUDO_OFFSET.INFO.isSupported(symbol);
    assert Type.INT(32).equals(imm.getType());

    this.rd = rd;
    this.symbol = symbol;
    this.imm = imm;

    addArgument("rd", rd);
    addArgument("symbol", symbol);
    addArgument("imm", imm);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    symbol.init(vars__);
    vars__.tmp_word.access().store(vars__.jump_imm32.access().load().add(Data.cast(Type.CARD(32), imm.access().load())));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("lh %s, %s%s%d", rd.text(vars__), symbol.text(vars__), ((imm.access().load().compareTo(Data.valueOf(Type.INT(32), 0x0)) < 0) ? "" : "+"), imm.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%s%s", new auipc(rd, new Immediate(vars__.tmp_word.access().bitField(31, 12))).image(vars__), new lh(rd, rd, new Immediate(vars__.tmp_word.access().bitField(11, 0))).image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new instruction(new auipc(rd, new Immediate(vars__.tmp_word.access().bitField(31, 12)))).execute(pe__, vars__);
    new instruction(new lh(rd, rd, new Immediate(vars__.tmp_word.access().bitField(11, 0)))).execute(pe__, vars__);
  }
}