/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class li32 extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "li32",
          li32.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("symbol", WORD);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final Immediate symbol = (Immediate) getArgument("symbol", args);

      return new li32(rd, symbol);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final X rd;
  public final Immediate symbol;

  public li32(final X rd, final Immediate symbol) {
    assert X.INFO.isSupported(rd);
    assert WORD.equals(symbol.getType());

    this.rd = rd;
    this.symbol = symbol;

    addArgument("rd", rd);
    addArgument("symbol", symbol);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("li %s, 0x%X", rd.text(vars__), symbol.access().load().bigIntegerValue(false));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("%s%s", new lui(rd, new Immediate(symbol.access().bitField(31, 12).load().add(Data.zeroExtend(Type.CARD(20), symbol.access().bitField(11, 11).load())))).image(vars__), new addi(rd, rd, new Immediate(symbol.access().bitField(11, 0))).image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    new instruction(new lui(rd, new Immediate(symbol.access().bitField(31, 12).load().add(Data.zeroExtend(Type.CARD(20), symbol.access().bitField(11, 11).load()))))).execute(pe__, vars__);
    new instruction(new addi(rd, rd, new Immediate(symbol.access().bitField(11, 0)))).execute(pe__, vars__);
  }
}