/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class li64 extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "li64",
          li64.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("symbol", DWORD);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final Immediate symbol = (Immediate) getArgument("symbol", args);

      return new li64(rd, symbol);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final X rd;
  public final Immediate symbol;

  public li64(final X rd, final Immediate symbol) {
    assert X.INFO.isSupported(rd);
    assert DWORD.equals(symbol.getType());

    this.rd = rd;
    this.symbol = symbol;

    addArgument("rd", rd);
    addArgument("symbol", symbol);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("li %s, 0x%X", rd.text(vars__), symbol.access().load().bigIntegerValue(false));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("%s%s%s%s%s%s%s", new li32(rd, new Immediate(symbol.access().bitField(63, 32))).image(vars__), new slli(rd, rd, new Immediate(Data.valueOf(Type.CARD(6), 0xb))).image(vars__), new ori(rd, rd, new Immediate(Data.zeroExtend(Type.CARD(12), symbol.access().bitField(31, 21).load()))).image(vars__), new slli(rd, rd, new Immediate(Data.valueOf(Type.CARD(6), 0xb))).image(vars__), new ori(rd, rd, new Immediate(Data.zeroExtend(Type.CARD(12), symbol.access().bitField(20, 10).load()))).image(vars__), new slli(rd, rd, new Immediate(Data.valueOf(Type.CARD(6), 0xa))).image(vars__), new ori(rd, rd, new Immediate(Data.zeroExtend(Type.CARD(12), symbol.access().bitField(9, 0).load()))).image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    new li32(rd, new Immediate(symbol.access().bitField(63, 32))).execute(pe__, vars__);
    new instruction(new slli(rd, rd, new Immediate(Data.valueOf(Type.CARD(6), 0xb)))).execute(pe__, vars__);
    new instruction(new ori(rd, rd, new Immediate(Data.zeroExtend(Type.CARD(12), symbol.access().bitField(31, 21).load())))).execute(pe__, vars__);
    new instruction(new slli(rd, rd, new Immediate(Data.valueOf(Type.CARD(6), 0xb)))).execute(pe__, vars__);
    new instruction(new ori(rd, rd, new Immediate(Data.zeroExtend(Type.CARD(12), symbol.access().bitField(20, 10).load())))).execute(pe__, vars__);
    new instruction(new slli(rd, rd, new Immediate(Data.valueOf(Type.CARD(6), 0xa)))).execute(pe__, vars__);
    new instruction(new ori(rd, rd, new Immediate(Data.zeroExtend(Type.CARD(12), symbol.access().bitField(9, 0).load())))).execute(pe__, vars__);
  }
}