/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class load_data extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "load_data",
          load_data.class,
          null
          );
      addArgument("op_type", Type.CARD(4));
      addArgument("address", XWORD);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate op_type = (Immediate) getArgument("op_type", args);
      final Immediate address = (Immediate) getArgument("address", args);

      return new load_data(op_type, address);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate op_type;
  public final Immediate address;

  public load_data(final Immediate op_type, final Immediate address) {
    assert Type.CARD(4).equals(op_type.getType());
    assert XWORD.equals(address.getType());

    this.op_type = op_type;
    this.address = address;

    addArgument("op_type", op_type);
    addArgument("address", address);
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.tmp_bit.access().store(Data.valueOf(BIT, 0x0));
    new check_aligned(op_type, address).execute(pe__, vars__);
    if (!vars__.tmp_bit.access().load().equals(Data.valueOf(BIT, 0x1))) {
      if (op_type.access().load().equals(Data.valueOf(Type.CARD(4), 0x8))) {
        vars__.load_value.access().bitField(63, 0).store(Location.concat(pe__.MEM.access(address.access().load().shiftRight(Data.valueOf(XWORD, 0x2)).add(Data.valueOf(XWORD, 0x1))), pe__.MEM.access(address.access().load().shiftRight(Data.valueOf(XWORD, 0x2)))));
      } else if (op_type.access().load().equals(Data.valueOf(Type.CARD(4), 0x4))) {
        vars__.load_value.access().store(Data.valueOf(DWORD, 0x0));
        vars__.load_value.access().bitField(31, 0).store(pe__.MEM.access(address.access().load().shiftRight(Data.valueOf(XWORD, 0x2))).load());
      }
    }
  }
}