/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class sraiw extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "sraiw",
          sraiw.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("rs1", X.INFO);
      addArgument("imm", Type.CARD(5));
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final X rs1 = (X) getArgument("rs1", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new sraiw(rd, rs1, imm);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "sraiw",
          instruction.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("rs1", X.INFO);
      addArgument("imm", Type.CARD(5));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final X rs1 = (X) getArgument("rs1", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new instruction(
        new sraiw(
          rd,
          rs1,
          imm
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final X rd;
  public final X rs1;
  public final Immediate imm;

  public sraiw(final X rd, final X rs1, final Immediate imm) {
    assert X.INFO.isSupported(rd);
    assert X.INFO.isSupported(rs1);
    assert Type.CARD(5).equals(imm.getType());

    this.rd = rd;
    this.rs1 = rs1;
    this.imm = imm;

    addArgument("rd", rd);
    addArgument("rs1", rs1);
    addArgument("imm", imm);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("sraiw %s, %s, 0x%x", rd.text(vars__), rs1.text(vars__), imm.access().load().bigIntegerValue(false));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("0100000%5s%s101%s0011011", imm.access().load().toString(), rs1.image(vars__), rd.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    rd.access(pe__, vars__).store(Data.signExtend(XWORD, Data.cast(INT, rs1.access(pe__, vars__).bitField(31, 0).load()).shiftRight(imm.access().load())));
  }
}