/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.decoder;

import static ru.ispras.microtesk.model.vliw.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.vliw.op.BFT;
import ru.ispras.microtesk.model.Immediate;
import ru.ispras.microtesk.model.IsaPrimitive;

/**
 * The {@code DecoderBFT} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderBFT extends DecoderItem {
  private static DecoderBFT instance = null;

  public static DecoderBFT get() {
    if (null == instance) {
      instance = new DecoderBFT();
    }
    return instance;
  }

  private DecoderBFT() {
    super(
        32,
        true,
        "01000101000000010000000000000000",
        "11111111111000110000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    Immediate cc = null;
    IsaPrimitive offset = null;

    if (!matchNextOpc(image, BitVector.valueOf("01000101000", 2, 11))) {
      return null;
    }

    cc = readNextImmediate(image, COND_CODE);

    if (!matchNextOpc(image, BitVector.valueOf("01", 2, 2))) {
      return null;
    }

    offset = (IsaPrimitive) readNextPrimitive(image, DecoderBRANCH_OFFSET.get());
    if (null == offset) {
      return null;
    }

    return newResult(new BFT(cc, offset));
  }
}
