/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vmem.mmu.sim;

import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.mmu.model.api.*;
import ru.ispras.fortress.data.types.bitvector.*;

/**
 * The {@code MEM} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class MEM extends Memory<MEM.Entry, PA> {
  private static MEM instance = null;

  public static MEM get() {
    if (null == instance) {
      instance = new MEM();
    }
    return instance;
  }

  public static final class Entry implements Data {
    public final BitVector data;

    public Entry() {
      this.data = BitVector.newEmpty(16);
    }

    public Entry(final BitVector value) {
      this();
      asBitVector().assign(value);
    }

    public void assign(final Entry other) {
      this.data.assign(other.data);
    }

    @Override
    public BitVector asBitVector() {
      return BitVector.newMapping(
          data
          );
    }

    @Override
    public String toString() {
      return String.format(
          "Entry [data=0x%s]",
          data.toHexString()
          );
    }
  }
  private MEM() {
    super(new BigInteger("4000", 16));
  }

  @Override
  protected PA newAddress() {
    return new PA();
  }

  @Override
  protected Entry newData(final BitVector value) {
    return new Entry(value);
  }

  @Override
  protected int getDataBitSize() {
    return 16;
  }
}
